import {
  PropertyType,
} from '@loafer/core/constants/types';
import ConfigurableEnvironment from '@loafer/core/env/ConfigurableEnvironment';
import ApplicationContext from '@loafer/context/ApplicationContext';
import Lifecycle from '@loafer/context/Lifecycle';

export interface ConfigurableApplicationContext extends ApplicationContext, Lifecycle {
	setId(id: PropertyType): void;
  setEnvironment(environment: ConfigurableEnvironment): void;
  getEnvironment(): ConfigurableEnvironment;
	addBeanFactoryPostProcessor(BeanFactoryPostProcessor postProcessor): void;
  addApplicationListener(ApplicationListener< ? > listener ): void;
  refresh(): void;
  getBeanFactory(): ConfigurableListablePouchFactory;
}

export default ConfigurableApplicationContext;
