import {
  PropertyType,
} from '@loafer/core/constants/types';

import {
  Decorator,
  DecoratorHandler,
} from '@loafer/core/decorator';

import Annotation from '@loafer/core/annotation/Annotation';

import {
  Class,
} from '@loafer/core/reflect';

export class PostConstructAnnotation extends Annotation implements DecoratorHandler {
  public onMethodDecorator = <T>(clazz: Class, target: Object, propertyKey: PropertyType,
                                 descriptor: TypedPropertyDescriptor<T>): TypedPropertyDescriptor<T> | void => {
    console.log('PostConstruct');
  }
}

export const PostConstruct = Decorator.create(PostConstructAnnotation);

export default PostConstruct;
