import {
  PropertyType,
} from '@loafer/core/constants/types';

import {
  Decorator,
  DecoratorHandler,
 } from '@loafer/core/decorator';

import {
  Class,
} from '@loafer/core/reflect';

import Annotation from '@loafer/core/annotation/Annotation';

export class ScopeAnnotation extends Annotation implements DecoratorHandler {
  private readonly Qualifier: PropertyType;

  public constructor(qualifier?: PropertyType) {
    super();
    this.Qualifier = qualifier;
  }
  public onClassDecorator = <TFunction extends Function>(clazz: Class, target: TFunction): TFunction | void => {
    console.log('Scope');
  }

}

export const Scope = Decorator.create(ScopeAnnotation);

export default Scope;
