import {
  ClassType,
  PropertyType,
} from '@loafer/core/constants/types';

import {
  Class,
} from '@loafer/core/reflect';

interface PouchFactory {
  /**
   * @param name is identity of pouch
   * @param type is type of pouch (if type is not specified, set the undefined)
   * @param args are argument of target constructor
   * @returns an instance of pouch
   */
  getPouch(name: PropertyType, type: ClassType, ...args: any[]): any;
  /**
   * @param type is type of pouch
   * @param qualifier is identity of pouch (if qualifier is not specified, set the undefined)
   * @param args are argument of target constructor
   * @returns an instance of pouch
   */
  getPouchByType(type: ClassType, ...args: any[]): any;

  containsPouch(name: string): boolean;
  isSingleton(name: string): boolean;
  isTransient(name: string): boolean;
  getClass(name: string): Class;
}

export default PouchFactory;
